

<script type="text/javascript">
  RED.nodes.registerType('mongoose', {
    category: 'custom',
    color: '#6cb059',
    defaults: {
      model_name: {
        required: true,
        validate:function(str){
          $.getJSON('/getModelFields/'+str, function(data1) {
            // data1.unshift("")
            $("#node-input-populate").typedInput({
              type: "population",
              types: [{
                value: "population",
                multiple:true,
                options: data1
              }]
            })

          });
          return true;
        }
      },
      method: {
        value: "findOne",
        required: true
      },
      condition: {
        value: '{}',
        required: true,
        validate: function(str) {
          try {
            JSON.parse(str);
          } catch (e) {
            return false;
          }
          return true;
        }
      },
      populate:{
        required:false,
        value:''
      }

    },

    inputs: 1,
    outputs: 2,
    icon: "mongoose.png",
  onchangeprepare:function(){
    console.log("changed")
  },
    oneditprepare: function() {

      $.getJSON('/getModels', function(data) {

        $("#node-input-model_name").typedInput({
          type: "model",
          types: [{
            value: "model",
            options: data
          }]
        })
      });

    },
    label: function() {

      return "mongoose " + (this.model_name || "") + " model";
    }
  });
</script>

<script type="text/html" data-template-name="mongoose">
  <div class="form-row">
    <label for="node-input-model_name"><i class="fa fa-tag"></i> Model Name</label>
    <input type="text" id="node-input-model_name">
    <br>
    <label for="node-input-method"><i class="fa fa-tag"></i> Method</label>

    <select id="node-input-method" name="method">
      <option value="findOne">FindOne</option>
      <option value="find">Find</option>
      <option value="deleteMany">Delete Many</option>
      <option value="update">Update</option>
      <option value="create">Create</option>
      <option value="insertMany">Bulk Create</option>
      <option value="count">Count</option>
    </select>

    <br>
    <label for="node-input-condition"><i class="fa fa-tag"></i> Condition</label>
    <input type="text" id="node-input-condition" placeholder="Condition must be a valid json" min="0">
<br>

    <label for="node-input-populate"><i class="fa fa-tag"></i> Populate</label>
    <input type="text" id="node-input-populate">
    <br>

  </div>
</script>

<script type="text/html" data-help-name="mongoose">
  <p>This node help to manage models and use mongoose features without code </p>
  <br>
  Paramaters :
  <ul>
    <li><b>Model Name : </b> choose on which model , the operation will be submitted</li>
    <li><b>Method : </b> the action to do on this model</li>
    <li><b>Condition :</b> A valid mongoose JSON-Object condition (optional) </li>
  </ul>

  The result of the node will be stored in <b>msg.result</b>
  </pre>
<br><br><br>
  <p style='color:red'>NB : the condition can takes the paramaters from the body of the request , but the node-red condition input still usually in priority when the field name is the same on both conditions </p>
</script>
